
/*  A Bison parser, made from /afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	NUMBER	258
#define	STRING	259
#define	IF	260
#define	ELSIF	261
#define	ELSE	262
#define	REJCT	263
#define	FILEINTO	264
#define	FORWARD	265
#define	KEEP	266
#define	STOP	267
#define	DISCARD	268
#define	VACATION	269
#define	REQUIRE	270
#define	ANYOF	271
#define	ALLOF	272
#define	EXISTS	273
#define	FALSE	274
#define	TRUE	275
#define	HEADER	276
#define	NOT	277
#define	SIZE	278
#define	ADDRESS	279
#define	ENVELOPE	280
#define	COMPARATOR	281
#define	IS	282
#define	CONTAINS	283
#define	MATCHES	284
#define	OVER	285
#define	UNDER	286
#define	ALL	287
#define	LOCALPART	288
#define	DOMAIN	289
#define	DAYS	290
#define	ADDRESSES	291
#define	SUBJECT	292
#define	MIME	293

#line 1 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"

/* sieve.y -- sieve parser
 * Larry Greenfield
 * $Id: sieve.y,v 1.2 1999/07/31 21:49:41 leg Exp $
 */
/***********************************************************
        Copyright 1999 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of Carnegie Mellon
University not be used in advertising or publicity pertaining to
distribution of the software without specific, written prior
permission.

CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE FOR
ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
******************************************************************/

#include <assert.h>
#include <string.h>
#include "comparator.h"
#include "interp.h"
#include "script.h"
#include "tree.h"

struct vtags {
    int days;
    stringlist_t *addresses;
    char *subject;
    int mime;
};

struct htags {
    char *comparator;
    int comptag;
};

struct aetags {
    int addrtag;
    char *comparator;
    int comptag;
};

static commandlist_t *ret;
static sieve_script_t *parse_script;
static int check_reqs(stringlist_t *sl);
static test_t *build_address(int t, struct aetags *ae,
			     stringlist_t *s1, stringlist_t *s2);
static test_t *build_header(int t, struct htags *h,
			    stringlist_t *s1, stringlist_t *s2);
static commandlist_t *build_vacation(int t, struct vtags *h, char *s);
static struct aetags *new_aetags(void);
static struct aetags *canon_aetags(struct aetags *ae);
static void free_aetags(struct aetags *ae);
static struct htags *new_htags(void);
static struct htags *canon_htags(struct htags *h);
static void free_htags(struct htags *h);
static struct vtags *new_vtags(void);
static struct vtags *canon_vtags(struct vtags *v);
static void free_vtags(struct vtags *v);

#define YYERROR_VERBOSE /* i want better error messages! */

#line 75 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
typedef union {
    int nval;
    char *sval;
    stringlist_t *sl;
    test_t *test;
    testlist_t *testl;
    commandlist_t *cl;
    struct vtags *vtag;
    struct aetags *aetag;
    struct htags *htag;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		101
#define	YYFLAG		-32768
#define	YYNTBASE	47

#define YYTRANSLATE(x) ((unsigned)(x) <= 293 ? yytranslate[x] : 67)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    45,
    46,     2,     2,    42,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    39,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    40,     2,    41,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    43,     2,    44,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,     5,     8,    12,    14,    17,    20,    25,
    28,    29,    34,    37,    40,    43,    46,    48,    50,    52,
    56,    57,    61,    65,    69,    72,    76,    78,    80,    84,
    88,    91,    94,    97,   100,   102,   104,   109,   114,   117,
   121,   123,   125,   127,   128,   131,   134,   138,   139,   142,
   146,   148,   150,   152,   154,   156,   158,   160,   162,   166,
   168
};

static const short yyrhs[] = {    -1,
    48,    50,     0,     0,    49,    48,     0,    15,    55,    39,
     0,    51,     0,    51,    50,     0,    53,    39,     0,     5,
    58,    57,    52,     0,     1,    39,     0,     0,     6,    58,
    57,    52,     0,     7,    57,     0,     8,     4,     0,     9,
    55,     0,    10,    55,     0,    11,     0,    12,     0,    13,
     0,    14,    54,     4,     0,     0,    54,    35,     3,     0,
    54,    36,    55,     0,    54,    37,     4,     0,    54,    38,
     0,    40,    56,    41,     0,     4,     0,     4,     0,     4,
    42,    56,     0,    43,    50,    44,     0,    43,    44,     0,
    16,    65,     0,    17,    65,     0,    18,    55,     0,    19,
     0,    20,     0,    21,    61,    55,    55,     0,    59,    60,
    55,    55,     0,    22,    58,     0,    23,    64,     3,     0,
     1,     0,    24,     0,    25,     0,     0,    60,    62,     0,
    60,    63,     0,    60,    26,     4,     0,     0,    61,    63,
     0,    61,    26,     4,     0,    32,     0,    33,     0,    34,
     0,    27,     0,    28,     0,    29,     0,    30,     0,    31,
     0,    45,    66,    46,     0,    58,     0,    58,    42,    66,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   106,   107,   110,   111,   114,   120,   121,   124,   125,   126,
   129,   130,   131,   134,   139,   148,   153,   154,   155,   156,
   166,   167,   170,   177,   183,   189,   190,   193,   194,   197,
   198,   201,   202,   203,   204,   205,   206,   210,   214,   215,
   217,   220,   221,   224,   225,   230,   234,   240,   241,   245,
   252,   253,   254,   257,   258,   259,   262,   263,   265,   268,
   269
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","NUMBER",
"STRING","IF","ELSIF","ELSE","REJCT","FILEINTO","FORWARD","KEEP","STOP","DISCARD",
"VACATION","REQUIRE","ANYOF","ALLOF","EXISTS","FALSE","TRUE","HEADER","NOT",
"SIZE","ADDRESS","ENVELOPE","COMPARATOR","IS","CONTAINS","MATCHES","OVER","UNDER",
"ALL","LOCALPART","DOMAIN","DAYS","ADDRESSES","SUBJECT","MIME","';'","'['","']'",
"','","'{'","'}'","'('","')'","start","reqs","require","commands","command",
"elsif","action","vtags","stringlist","strings","block","test","addrorenv","aetags",
"htags","addrparttag","comptag","sizetag","testlist","tests", NULL
};
#endif

static const short yyr1[] = {     0,
    47,    47,    48,    48,    49,    50,    50,    51,    51,    51,
    52,    52,    52,    53,    53,    53,    53,    53,    53,    53,
    54,    54,    54,    54,    54,    55,    55,    56,    56,    57,
    57,    58,    58,    58,    58,    58,    58,    58,    58,    58,
    58,    59,    59,    60,    60,    60,    60,    61,    61,    61,
    62,    62,    62,    63,    63,    63,    64,    64,    65,    66,
    66
};

static const short yyr2[] = {     0,
     0,     2,     0,     2,     3,     1,     2,     2,     4,     2,
     0,     4,     2,     2,     2,     2,     1,     1,     1,     3,
     0,     3,     3,     3,     2,     3,     1,     1,     3,     3,
     2,     2,     2,     2,     1,     1,     4,     4,     2,     3,
     1,     1,     1,     0,     2,     2,     3,     0,     2,     3,
     1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
     3
};

static const short yydefact[] = {     3,
     0,     0,     3,    27,     0,     0,     0,     0,     0,     0,
     0,    17,    18,    19,    21,     2,     0,     0,     4,    28,
     0,     5,    10,    41,     0,     0,     0,    35,    36,    48,
     0,     0,    42,    43,     0,    44,    14,    15,    16,     0,
     7,     8,     0,    26,     0,    32,    33,    34,     0,    39,
    57,    58,     0,     0,    11,     0,    20,     0,     0,     0,
    25,    29,    60,     0,     0,    54,    55,    56,     0,    49,
    40,    31,     0,     0,     0,     9,     0,    51,    52,    53,
     0,    45,    46,    22,    23,    24,     0,    59,    50,    37,
    30,     0,    13,    47,    38,    61,    11,    12,     0,     0,
     0
};

static const short yydefgoto[] = {    99,
     2,     3,    16,    17,    76,    18,    40,     6,    21,    55,
    63,    36,    56,    49,    82,    70,    53,    46,    64
};

static const short yypact[] = {    16,
     2,    79,   -11,-32768,    28,   -25,    -3,    81,    33,     2,
     2,-32768,-32768,-32768,-32768,-32768,    10,    -1,-32768,     5,
     3,-32768,-32768,-32768,    -2,    -2,     2,-32768,-32768,-32768,
    81,   -23,-32768,-32768,     8,-32768,-32768,-32768,-32768,    41,
-32768,-32768,    28,-32768,    81,-32768,-32768,-32768,    46,-32768,
-32768,-32768,    45,    52,     6,     1,-32768,    49,     2,    51,
-32768,-32768,    14,    12,    63,-32768,-32768,-32768,     2,-32768,
-32768,-32768,    25,    81,     8,-32768,    66,-32768,-32768,-32768,
     2,-32768,-32768,-32768,-32768,-32768,    81,-32768,-32768,-32768,
-32768,     8,-32768,-32768,-32768,-32768,     6,-32768,    83,    85,
-32768
};

static const short yypgoto[] = {-32768,
    78,-32768,   -14,-32768,    11,-32768,-32768,   -10,    64,   -66,
    -6,-32768,-32768,-32768,-32768,    38,-32768,    69,    22
};


#define	YYLAST		109


static const short yytable[] = {    38,
    39,    35,    41,     1,     4,     4,    51,    52,    93,    -6,
     7,    74,    75,    22,     8,    -1,    48,     9,    10,    11,
    12,    13,    14,    15,    50,    97,    77,    66,    67,    68,
     1,    20,    78,    79,    80,    23,    37,    42,    69,    73,
     5,     5,    45,    44,    57,    81,    43,    71,    85,     4,
    54,    84,     7,    -6,    86,    87,     8,    88,    90,     9,
    10,    11,    12,    13,    14,    15,    89,    92,    91,    94,
    95,    65,    66,    67,    68,    58,    59,    60,    61,     7,
    19,    24,   100,     8,   101,     5,     9,    10,    11,    12,
    13,    14,    15,    83,    47,    72,    25,    26,    27,    28,
    29,    30,    31,    32,    33,    34,    62,    98,    96
};

static const short yycheck[] = {    10,
    11,     8,    17,    15,     4,     4,    30,    31,    75,     0,
     1,     6,     7,    39,     5,     0,    27,     8,     9,    10,
    11,    12,    13,    14,    31,    92,    26,    27,    28,    29,
    15,     4,    32,    33,    34,    39,     4,    39,    49,    54,
    40,    40,    45,    41,     4,    56,    42,     3,    59,     4,
    43,     3,     1,    44,     4,    42,     5,    46,    69,     8,
     9,    10,    11,    12,    13,    14,     4,    74,    44,     4,
    81,    26,    27,    28,    29,    35,    36,    37,    38,     1,
     3,     1,     0,     5,     0,    40,     8,     9,    10,    11,
    12,    13,    14,    56,    26,    44,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    43,    97,    87
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/share/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/local/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 106 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ ret = NULL; ;
    break;}
case 2:
#line 107 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ ret = yyvsp[0].cl; ;
    break;}
case 5:
#line 114 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ if (!check_reqs(yyvsp[-1].sl)) {
                                    yyerror("unsupported feature");
				    YYERROR; 
                                  } ;
    break;}
case 6:
#line 120 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.cl = yyvsp[0].cl; ;
    break;}
case 7:
#line 121 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyvsp[-1].cl->next = yyvsp[0].cl; yyval.cl = yyvsp[-1].cl; ;
    break;}
case 8:
#line 124 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.cl = yyvsp[-1].cl; ;
    break;}
case 9:
#line 125 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.cl = new_if(yyvsp[-2].test, yyvsp[-1].cl, yyvsp[0].cl); ;
    break;}
case 10:
#line 126 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.cl = new_command(STOP); ;
    break;}
case 11:
#line 129 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.cl = NULL; ;
    break;}
case 12:
#line 130 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.cl = new_if(yyvsp[-2].test, yyvsp[-1].cl, yyvsp[0].cl); ;
    break;}
case 13:
#line 131 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.cl = yyvsp[0].cl; ;
    break;}
case 14:
#line 134 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ if (!parse_script->support.reject) {
				     yyerror("reject not required");
				     YYERROR;
				   }
				   yyval.cl = new_command(REJCT); yyval.cl->u.str = yyvsp[0].sval; ;
    break;}
case 15:
#line 139 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ if (!parse_script->support.fileinto) {
				     yyerror("fileinto not required");
	                             YYERROR;
                                   }
				   if (!verify_mailboxes(yyvsp[0].sl)) {
				     YYERROR; /* vm should call yyerror() */
				   }
	                           yyval.cl = new_command(FILEINTO);
				   yyval.cl->u.sl = yyvsp[0].sl; ;
    break;}
case 16:
#line 148 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.cl = new_command(FORWARD);
				   if (!verify_addresses(yyvsp[0].sl)) {
				     YYERROR; /* va should call yyerror() */
				   }
				   yyval.cl->u.sl = yyvsp[0].sl; ;
    break;}
case 17:
#line 153 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.cl = new_command(KEEP); ;
    break;}
case 18:
#line 154 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.cl = new_command(STOP); ;
    break;}
case 19:
#line 155 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.cl = new_command(DISCARD); ;
    break;}
case 20:
#line 156 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ if (!parse_script->support.vacation) {
				     yyerror("vacation not required");
				     yyval.cl = new_command(VACATION);
				     YYERROR;
				   } else {
  				     yyval.cl = build_vacation(VACATION,
					    canon_vtags(yyvsp[-1].vtag), yyvsp[0].sval);
				   } ;
    break;}
case 21:
#line 166 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.vtag = new_vtags(); ;
    break;}
case 22:
#line 167 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ if (yyval.vtag->days != -1) { 
					yyerror("duplicate :days"); YYERROR; }
				   else { yyval.vtag->days = yyvsp[0].nval; } ;
    break;}
case 23:
#line 170 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ if (yyval.vtag->addresses != NULL) { 
					yyerror("duplicate :addresses"); 
					YYERROR;
				       } else if (!verify_addresses(yyvsp[0].sl)) {
					  YYERROR;
				       } else {
					 yyval.vtag->addresses = yyvsp[0].sl; } ;
    break;}
case 24:
#line 177 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ if (yyval.vtag->subject != NULL) { 
					yyerror("duplicate :subject"); 
					YYERROR;
				   } else if (!ok_header(yyvsp[0].sval)) {
					YYERROR;
				   } else { yyval.vtag->subject = yyvsp[0].sval; } ;
    break;}
case 25:
#line 183 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ if (yyval.vtag->mime != -1) { 
					yyerror("duplicate :mime"); 
					YYERROR; }
				   else { yyval.vtag->mime = MIME; } ;
    break;}
case 26:
#line 189 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.sl = yyvsp[-1].sl; ;
    break;}
case 27:
#line 190 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.sl = new_sl(yyvsp[0].sval, NULL); ;
    break;}
case 28:
#line 193 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.sl = new_sl(yyvsp[0].sval, NULL); ;
    break;}
case 29:
#line 194 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.sl = new_sl(yyvsp[-2].sval, yyvsp[0].sl); ;
    break;}
case 30:
#line 197 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.cl = yyvsp[-1].cl; ;
    break;}
case 31:
#line 198 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.cl = NULL; ;
    break;}
case 32:
#line 201 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.test = new_test(ANYOF); yyval.test->u.tl = yyvsp[0].testl; ;
    break;}
case 33:
#line 202 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.test = new_test(ALLOF); yyval.test->u.tl = yyvsp[0].testl; ;
    break;}
case 34:
#line 203 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.test = new_test(EXISTS); yyval.test->u.sl = yyvsp[0].sl; ;
    break;}
case 35:
#line 204 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.test = new_test(FALSE); ;
    break;}
case 36:
#line 205 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.test = new_test(TRUE); ;
    break;}
case 37:
#line 207 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.test = build_header(HEADER, canon_htags(yyvsp[-2].htag), 
						     yyvsp[-1].sl, yyvsp[0].sl);
				   if (yyval.test == NULL) { YYERROR; } ;
    break;}
case 38:
#line 211 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.test = build_address(yyvsp[-3].nval, canon_aetags(yyvsp[-2].aetag), 
						      yyvsp[-1].sl, yyvsp[0].sl); 
				   if (yyval.test == NULL) { YYERROR; } ;
    break;}
case 39:
#line 214 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.test = new_test(NOT); yyval.test->u.t = yyvsp[0].test; ;
    break;}
case 40:
#line 215 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.test = new_test(SIZE); yyval.test->u.sz.t = yyvsp[-1].nval;
		                   yyval.test->u.sz.n = yyvsp[0].nval; ;
    break;}
case 41:
#line 217 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.test = NULL; ;
    break;}
case 42:
#line 220 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.nval = ADDRESS; ;
    break;}
case 43:
#line 221 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.nval = ENVELOPE; ;
    break;}
case 44:
#line 224 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.aetag = new_aetags(); ;
    break;}
case 45:
#line 225 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.aetag = yyvsp[-1].aetag;
				   if (yyval.aetag->addrtag != -1) { 
			yyerror("duplicate or conflicting address part tag");
			YYERROR; }
				   else { yyval.aetag->addrtag = yyvsp[0].nval; } ;
    break;}
case 46:
#line 230 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.aetag = yyvsp[-1].aetag;
				   if (yyval.aetag->comptag != -1) { 
			yyerror("duplicate comparator type tag"); YYERROR; }
				   else { yyval.aetag->comptag = yyvsp[0].nval; } ;
    break;}
case 47:
#line 234 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.aetag = yyvsp[-2].aetag;
				   if (yyval.aetag->comparator != NULL) { 
			yyerror("duplicate comparator tag"); YYERROR; }
				   else { yyval.aetag->comparator = yyvsp[0].sval; } ;
    break;}
case 48:
#line 240 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.htag = new_htags(); ;
    break;}
case 49:
#line 241 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.htag = yyvsp[-1].htag;
				   if (yyval.htag->comptag != -1) { 
			yyerror("duplicate comparator type tag"); YYERROR; }
				   else { yyval.htag->comptag = yyvsp[0].nval; } ;
    break;}
case 50:
#line 245 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.htag = yyvsp[-2].htag;
				   if (yyval.htag->comparator != NULL) { 
			yyerror("duplicate comparator tag");
					YYERROR; }
				   else { yyval.htag->comparator = yyvsp[0].sval; } ;
    break;}
case 51:
#line 252 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.nval = ALL; ;
    break;}
case 52:
#line 253 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.nval = LOCALPART; ;
    break;}
case 53:
#line 254 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.nval = DOMAIN; ;
    break;}
case 54:
#line 257 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.nval = IS; ;
    break;}
case 55:
#line 258 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.nval = CONTAINS; ;
    break;}
case 56:
#line 259 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.nval = MATCHES; ;
    break;}
case 57:
#line 262 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.nval = OVER; ;
    break;}
case 58:
#line 263 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.nval = UNDER; ;
    break;}
case 59:
#line 265 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.testl = yyvsp[-1].testl; ;
    break;}
case 60:
#line 268 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.testl = new_testlist(yyvsp[0].test, NULL); ;
    break;}
case 61:
#line 269 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"
{ yyval.testl = new_testlist(yyvsp[-2].test, yyvsp[0].testl); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/local/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 272 "/afs/andrew.cmu.edu/system/src/local/cyrus/031/cyrus/sieve/sieve.y"

commandlist_t *sieve_parse(sieve_script_t *script, FILE *f)
{
    commandlist_t *t;
    extern FILE *yyin;

    yyin = f;
    parse_script = script;
    if (yyparse()) {
	t = NULL;
    } else {
	t = ret;
    }
    ret = NULL;
    return t;
}

int yyerror(char *msg)
{
    extern int yylineno;
    extern char *yytext;

    script_push_error(parse_script, msg, yylineno);
    return 0;
}

static int check_reqs(stringlist_t *sl)
{
    int i = 1;
    stringlist_t *s;
    
    while (sl != NULL) {
	s = sl;
	sl = sl->next;

	i &= script_require(parse_script, s->s);

	if (s->s) free(s->s);
	free(s);
    }
    return i;
}

static test_t *build_address(int t, struct aetags *ae,
			     stringlist_t *s1, stringlist_t *s2)
{
    test_t *ret = new_test(t);	/* can be either ADDRESS or ENVELOPE */

    assert((t == ADDRESS) || (t == ENVELOPE));

    if (ret) {
	ret->u.ae.comp = lookup_comp(ae->comparator, ae->comptag);
	ret->u.ae.s1 = s1;
	ret->u.ae.s2 = s2;
	ret->u.ae.addrpart = ae->addrtag;
	free_aetags(ae);
	if (ret->u.ae.comp == NULL) {
	    free_test(ret);
	    ret = NULL;
	}
    }
    return ret;
}

static test_t *build_header(int t, struct htags *h,
			    stringlist_t *s1, stringlist_t *s2)
{
    test_t *ret = new_test(t);	/* can be HEADER */

    assert(t == HEADER);

    if (ret) {
	ret->u.h.comp = lookup_comp(h->comparator, h->comptag);
	ret->u.h.s1 = s1;
	ret->u.h.s2 = s2;
	free_htags(h);
	if (ret->u.ae.comp == NULL) {
	    free_test(ret);
	    ret = NULL;
	}
    }
    return ret;
}

static commandlist_t *build_vacation(int t, struct vtags *v, char *reason)
{
    commandlist_t *ret = new_command(t);

    assert(t == VACATION);

    if (ret) {
	ret->u.v.subject = v->subject; v->subject = NULL;
	ret->u.v.days = v->days;
	ret->u.v.mime = v->mime;
	ret->u.v.addresses = v->addresses; v->addresses = NULL;
	free_vtags(v);
	ret->u.v.message = reason;
    }
    return ret;
}

static struct aetags *new_aetags(void)
{
    struct aetags *r = (struct aetags *) xmalloc(sizeof(struct aetags));

    r->addrtag = r->comptag = -1;
    r->comparator = NULL;

    return r;
}

static struct aetags *canon_aetags(struct aetags *ae)
{
    if (ae->addrtag == -1) { ae->addrtag = ALL; }
    if (ae->comparator == NULL) { ae->comparator = strdup("i;ascii-casemap"); }
    if (ae->comptag == -1) { ae->comptag = IS; }
    return ae;
}

static void free_aetags(struct aetags *ae)
{
    free(ae->comparator);
    free(ae);
}

static struct htags *new_htags(void)
{
    struct htags *r = (struct htags *) xmalloc(sizeof(struct htags));

    r->comptag = -1;
    r->comparator = NULL;

    return r;
}

static struct htags *canon_htags(struct htags *h)
{
    if (h->comparator == NULL) { h->comparator = strdup("i;ascii-casemap"); }
    if (h->comptag == -1) { h->comptag = IS; }
    return h;
}

static void free_htags(struct htags *h)
{
    free(h->comparator);
    free(h);
}

static struct vtags *new_vtags(void)
{
    struct vtags *r = (struct vtags *) xmalloc(sizeof(struct vtags));

    r->days = -1;
    r->addresses = NULL;
    r->subject = NULL;
    r->mime = -1;

    return r;
}

static struct vtags *canon_vtags(struct vtags *v)
{
    assert(parse_script->interp.vacation != NULL);

    if (v->days == -1) { v->days = 7; }
    if (v->days < parse_script->interp.vacation->min_response) 
       { v->days = parse_script->interp.vacation->min_response; }
    if (v->days > parse_script->interp.vacation->max_response)
       { v->days = parse_script->interp.vacation->max_response; }
    if (v->mime == -1) { v->mime = 0; }

    return v;
}

static void free_vtags(struct vtags *v)
{
    if (v->addresses) { free_sl(v->addresses); }
    if (v->subject) { free(v->subject); }
    free(v);
}

static int verify_address(char *s)
{
    /* if not an address, call yyerror */
    return 1;
}

static int verify_addresses(stringlist_t *sl)
{
    for (; sl != NULL && verify_address(sl->s); sl = sl->next) ;
    return (sl == NULL);
}

static int verify_mailbox(char *s)
{
    /* if not a mailbox, call yyerror */
    return 1;
}

static int verify_mailboxes(stringlist_t *sl)
{
    for (; sl != NULL && verify_mailbox(sl->s); sl = sl->next) ;
    return (sl == NULL);
}

/* is it ok to put this in an RFC822 header body? */
static int ok_header(char *s)
{
    return 1;
}